package ecp.vcs.com.vcs_plugin;

import android.Manifest;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.pm.PackageManager;
import android.net.Uri;
import android.os.Build;
import android.provider.Settings;
import android.util.Log;

import androidx.annotation.NonNull;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;

import com.zebra.rfid.api3.TagData;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import io.flutter.plugin.common.EventChannel;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry;

/**
 * VcsPlugin
 */
/*public class VcsPlugin implements MethodCallHandler, EventChannel.StreamHandler {

    private static Registrar registrar;
    //private final PluginRegistry.Registrar registrar;
    private BroadcastReceiver chargingStateChangeReceiver;
    private static final String update_progress = "update_progress";

    */

/**
 * Plugin registration.
 *//*
    public static void registerWith(Registrar _registrar) {
        registrar = _registrar;
        final MethodChannel channel = new MethodChannel(registrar.messenger(), "vcs_plugin");
        channel.setMethodCallHandler(new VcsPlugin());

        final EventChannel eventChannel =
                new EventChannel(registrar.messenger(), "ecp_sync_plugin_Progress");
        final VcsPlugin instance = new VcsPlugin(registrar);
        eventChannel.setStreamHandler(instance);

    }

    private VcsPlugin(PluginRegistry.Registrar registrar) {
        this.registrar = registrar;
    }

    @Override
    public void onListen(Object arguments, EventChannel.EventSink events) {
        Log.e("BroadCast", "onListen");
        chargingStateChangeReceiver = createChargingStateChangeReceiver(events);
        registrar
                .context()
                .registerReceiver(
                        chargingStateChangeReceiver, new IntentFilter(update_progress));
    }

    @Override
    public void onCancel(Object arguments) {
        Log.e("BroadCast", "onCancel");
        registrar.context().unregisterReceiver(chargingStateChangeReceiver);
        chargingStateChangeReceiver = null;
    }


    private final BroadcastReceiver mReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            Log.e("BroadCast", " onRecieve"); //do something with intent
            if (intent.getExtras() != null) {
                String SCAN = intent.getExtras().getString("SCAN");
                String JSONDATA = intent.getExtras().getString("JSONDATA");
                assert SCAN != null;
                if (SCAN.equalsIgnoreCase("done")) {
                    Log.e("BroadCast", "JSONDATA:" + JSONDATA);
                    sendBroadCastDetails(11, JSONDATA, 0);
                    registrar.activity().unregisterReceiver(mReceiver);
                } else {
                    sendBroadCastDetails(12, JSONDATA, 0);
                    registrar.activity().unregisterReceiver(mReceiver);
                }
            }
        }
    };

    private BroadcastReceiver createChargingStateChangeReceiver(final EventChannel.EventSink events) {
        return new BroadcastReceiver() {
            @Override
            public void onReceive(Context context, Intent intent) {
                int type = intent.getIntExtra("type", -1);
                int progress = intent.getIntExtra("progress", -1);
                String Details = intent.getStringExtra("details");

                Map<String, String> parameterPost = new HashMap<>();
                parameterPost.clear();
                parameterPost.put("type", String.valueOf(type));
                parameterPost.put("progress", String.valueOf(progress));
                parameterPost.put("Details", Details);

                events.success(parameterPost);
            }
        };
    }

    @Override
    public void onMethodCall(MethodCall call, Result result) {
        if (call.method.equals("getPlatformVersion")) {
            //result.success("Android " + android.os.Build.VERSION.RELEASE);
            String urlString = "https://demo-isight.ecubix.com/pages/auth/login";
            Intent intent = new Intent(Intent.ACTION_VIEW, Uri.parse(urlString));
            intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
            intent.setPackage("com.android.chrome");
            try {
                registrar.activity().startActivity(intent);
            } catch (ActivityNotFoundException ex) {
                // Chrome browser presumably not installed so allow user to choose instead
                intent.setPackage(null);
                registrar.activity().startActivity(intent);
            }
        }
        if (call.method.equals("setDaySeven")) {
            sendBroadCastDetails(1, "devv", 20);
            result.success("done");
        }
        if (call.method.equals("setDayOne")) {

        } else {
            result.notImplemented();
        }
    }

    private void sendBroadCastDetails(int type, String details, int progress) {
        //type = 1 => progress, 2 => errors, 3 => sync complate
        Log.e("sendBroadCastDetails", "sendBroadCastDetails");
        Intent intent = new Intent(update_progress);
        intent.putExtra("type", type);
        intent.putExtra("progress", progress);
        intent.putExtra("details", details);
        this.registrar.context().sendBroadcast(intent);
    }

    private void setWorkManager(int days) {
        *//*Constraints constraints = new Constraints.Builder()
                //.setRequiresDeviceIdle(false)
                //.setRequiresBatteryNotLow(true)
                //.setRequiresCharging(false)
                .build();

        PeriodicWorkRequest saveRequest =
                new PeriodicWorkRequest.Builder(MyBackWorkert.class, 16, TimeUnit.MINUTES)
                        .setConstraints(constraints)
                        .build();

        WorkManager.getInstance(myContext).enqueueUniquePeriodicWork(SYNC_TIME_WORK_NAME, ExistingPeriodicWorkPolicy.REPLACE, saveRequest);*//*
    }
}*/

interface ResponseHandlerInterface {
    void handleTagdata(TagData[] tagData);

    void handleTriggerPress(boolean pressed);
    //void handleStatusEvents(Events.StatusEventData eventData);

    void checkConnected(boolean pressed,String details);
}


public class VcsPlugin implements MethodCallHandler, EventChannel.StreamHandler, ResponseHandlerInterface {
    /**
     * Plugin registration.
     *//*
  public static void registerWith(Registrar registrar) {
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "ecp_sync_plugin");
    channel.setMethodCallHandler(new VcsPlugin());
  }

  @Override
  public void onMethodCall(MethodCall call, Result result) {
    if (call.method.equals("getPlatformVersion")) {
      result.success("Android " + android.os.Build.VERSION.RELEASE);
    } else {
      result.notImplemented();
    }
  }*/


    // --Commented out by Inspection (03/04/19, 2:41 PM):private static boolean isFielCopeError = false;
    // --Commented out by Inspection (03/04/19, 2:41 PM):private static String fileCopeException = "";
    private static String URLDownloadDB = "";


    private static final String update_progress = "update_progress";
    private static final int REQUEST_ID_MULTIPLE_PERMISSIONS = 1;

    private final BroadcastReceiver mReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            Log.e("BroadCast", " onRecieve"); //do something with intent
            if (intent.getExtras() != null) {
                String SCAN = intent.getExtras().getString("SCAN");
                String JSONDATA = intent.getExtras().getString("JSONDATA");
                assert SCAN != null;
                if (SCAN.equalsIgnoreCase("done")) {
                    Log.e("BroadCast", "JSONDATA:" + JSONDATA);
                    sendBroadCastDetails(11, JSONDATA, 0);
                    registrar.activity().unregisterReceiver(mReceiver);
                } else {
                    sendBroadCastDetails(12, JSONDATA, 0);
                    registrar.activity().unregisterReceiver(mReceiver);
                }
            }
        }
    };

    public static void registerWith(final PluginRegistry.Registrar registrar) {
        final MethodChannel methodChannel =
                new MethodChannel(registrar.messenger(), "ecp_sync_plugin_dev");
        final EventChannel eventChannel =
                new EventChannel(registrar.messenger(), "ecp_sync_plugin_Progress_dev");
        final VcsPlugin instance = new VcsPlugin(registrar);
        eventChannel.setStreamHandler(instance);
        methodChannel.setMethodCallHandler(instance);

        registrar.addRequestPermissionsResultListener(new PluginRegistry.RequestPermissionsResultListener() {
            @Override
            public boolean onRequestPermissionsResult(int i, String[] strings, int[] ints) {
                return detailsPermission(i, strings, ints, registrar.activity());
            }
        });


    }

    private VcsPlugin(PluginRegistry.Registrar registrar) {
        this.registrar = registrar;
    }

    private final PluginRegistry.Registrar registrar;
    private BroadcastReceiver chargingStateChangeReceiver;
    private RFIDHandler rfidHandler;

    private Context getActiveContext() {
        return (registrar.activity() != null) ? registrar.activity() : registrar.context();
    }

    @Override
    public void onMethodCall(MethodCall call, Result result) {

        if (call.method.equals("setDaySeven")) {


            /*Timer timerObj = new Timer();
            TimerTask timerTaskObj = new TimerTask() {
                public void run() {
                    //perform your action here

                    sendBroadCastDetails(1, "devv", 20);
                }
            };
            timerObj.schedule(timerTaskObj, 0, 5000);
            result.success("done");*/

            rfidHandler = new RFIDHandler();
            rfidHandler.onCreate(registrar, this);
            //rfidHandler.Defaults();


        }else if (call.method.equals("setDaySevenDefault")) {


            /*Timer timerObj = new Timer();
            TimerTask timerTaskObj = new TimerTask() {
                public void run() {
                    //perform your action here

                    sendBroadCastDetails(1, "devv", 20);
                }
            };
            timerObj.schedule(timerTaskObj, 0, 5000);
            result.success("done");*/

            //rfidHandler = new RFIDHandler();
            //rfidHandler.onCreate(registrar, this);
            rfidHandler.Defaults();


        } else {
            result.notImplemented();
        }
    }


    @Override
    public void onListen(Object arguments, EventChannel.EventSink events) {
        Log.e("BroadCast", "onListen");
        chargingStateChangeReceiver = createChargingStateChangeReceiver(events);
        registrar
                .context()
                .registerReceiver(
                        chargingStateChangeReceiver, new IntentFilter(update_progress));
    }

    @Override
    public void onCancel(Object arguments) {
        Log.e("BroadCast", "onCancel");
        registrar.context().unregisterReceiver(chargingStateChangeReceiver);
        chargingStateChangeReceiver = null;
    }

    private void sendBroadCastDetails(int type, String details, int progress) {
        //type = 1 => progress, 2 => errors, 3 => sync complate
        Log.e("sendBroadCastDetails", "sendBroadCastDetails");
        Intent intent = new Intent(update_progress);
        intent.putExtra("type", type);
        intent.putExtra("progress", progress);
        intent.putExtra("details", details);
        this.registrar.context().sendBroadcast(intent);
    }

    private BroadcastReceiver createChargingStateChangeReceiver(final EventChannel.EventSink events) {
        return new BroadcastReceiver() {
            @Override
            public void onReceive(Context context, Intent intent) {
                int type = intent.getIntExtra("type", -1);
                int progress = intent.getIntExtra("progress", -1);
                String Details = intent.getStringExtra("details");

                Map<String, String> parameterPost = new HashMap<>();
                parameterPost.clear();
                parameterPost.put("type", String.valueOf(type));
                parameterPost.put("progress", String.valueOf(progress));
                parameterPost.put("Details", Details);

                events.success(parameterPost);
            }
        };
    }


    private static boolean checkAndRequestPermissions(Activity registrar) {
        if (Build.VERSION.SDK_INT >= 23) {
            int permissionStorage = ContextCompat.checkSelfPermission(registrar,
                    Manifest.permission.WRITE_EXTERNAL_STORAGE);
            // int locationPermission = ContextCompat.checkSelfPermission(registrar.activity(), Manifest.permission.ACCESS_FINE_LOCATION);
            int cameraPermission = ContextCompat.checkSelfPermission(registrar, Manifest.permission.CAMERA);
            //int contactsPermission = ContextCompat.checkSelfPermission(registrar, Manifest.permission.GET_ACCOUNTS);
            int callPhonePermission = ContextCompat.checkSelfPermission(registrar, Manifest.permission.READ_PHONE_STATE);
            //int receiveSMSPermission = ContextCompat.checkSelfPermission(registrar.activity(), Manifest.permission.RECEIVE_SMS);

            List<String> listPermissionsNeeded = new ArrayList<>();
            /*if (locationPermission != PackageManager.PERMISSION_GRANTED) {
                listPermissionsNeeded.add(Manifest.permission.ACCESS_FINE_LOCATION);
            }*/
            if (permissionStorage != PackageManager.PERMISSION_GRANTED) {
                listPermissionsNeeded.add(Manifest.permission.WRITE_EXTERNAL_STORAGE);
            }
            if (cameraPermission != PackageManager.PERMISSION_GRANTED) {
                listPermissionsNeeded.add(Manifest.permission.CAMERA);
            }
            //if (contactsPermission != PackageManager.PERMISSION_GRANTED) {
            // listPermissionsNeeded.add(Manifest.permission.GET_ACCOUNTS);
            //}
            if (callPhonePermission != PackageManager.PERMISSION_GRANTED) {
                listPermissionsNeeded.add(Manifest.permission.READ_PHONE_STATE);
            }
            /*if (receiveSMSPermission != PackageManager.PERMISSION_GRANTED) {
                listPermissionsNeeded.add(Manifest.permission.RECEIVE_SMS);
            }*/
            if (!listPermissionsNeeded.isEmpty()) {
                ActivityCompat.requestPermissions(registrar, listPermissionsNeeded.toArray(new String[0]), REQUEST_ID_MULTIPLE_PERMISSIONS);
                return false;
            }
        }
        return true;
    }

    private static boolean detailsPermission(int requestCode, @NonNull String permissions[], @NonNull int[] grantResults, Activity context) {
        String TAG = "Permission";
        Log.d(TAG, "Permission callback called-------");
        if (requestCode == REQUEST_ID_MULTIPLE_PERMISSIONS) {
            //case REQUEST_ID_MULTIPLE_PERMISSIONS: {
            Map<String, Integer> perms = new HashMap<>();
            // Initialize the map with both permissions
            perms.put(Manifest.permission.CAMERA, PackageManager.PERMISSION_GRANTED);
            perms.put(Manifest.permission.WRITE_EXTERNAL_STORAGE, PackageManager.PERMISSION_GRANTED);
            perms.put(Manifest.permission.READ_PHONE_STATE, PackageManager.PERMISSION_GRANTED);
            //perms.put(Manifest.permission.GET_ACCOUNTS, PackageManager.PERMISSION_GRANTED);

            // Fill with actual results from user
            if (grantResults.length > 0) {
                for (int i = 0; i < permissions.length; i++)
                    perms.put(permissions[i], grantResults[i]);
                // Check for both permissions
                if (perms.get(Manifest.permission.CAMERA) == PackageManager.PERMISSION_GRANTED
                        && perms.get(Manifest.permission.WRITE_EXTERNAL_STORAGE) == PackageManager.PERMISSION_GRANTED
                        //&& perms.get(Manifest.permission.GET_ACCOUNTS) == PackageManager.PERMISSION_GRANTED
                        && perms.get(Manifest.permission.READ_PHONE_STATE) == PackageManager.PERMISSION_GRANTED) {
                    Log.e(TAG, "All permission granted");
//                        init();
                    return true;

                } else {
                    Log.e(TAG, "Some permissions are not granted ask again ");
                    if (ActivityCompat.shouldShowRequestPermissionRationale(context, Manifest.permission.CAMERA)
                            || ActivityCompat.shouldShowRequestPermissionRationale(context, Manifest.permission.WRITE_EXTERNAL_STORAGE)
                            //|| ActivityCompat.shouldShowRequestPermissionRationale(context, Manifest.permission.GET_ACCOUNTS)
                            || ActivityCompat.shouldShowRequestPermissionRationale(context, Manifest.permission.READ_PHONE_STATE)) {
                        //showAlertWithOkButtonCallback(1, "Some Permission required for use this app.","");
                        Log.e(TAG, "Some Permission required for use this app.");
                        return false;
                    } else {
                        showAlertWithOkButtonCallback(2, "Some permissions needed. Please allow in App Settings for additional functionality.", "", context);
                        return false;
                    }
                }
            } else {
                return false;
            }
            //}
        } else {
            return false;
        }
    }

    private static void showAlertWithOkButtonCallback(final int type, String text, String app_name, final Activity activity) {

        AlertDialog.Builder builder =
                new AlertDialog.Builder(activity);
        builder.setTitle(app_name);
        builder.setMessage(text);
        builder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                if (type == 1) {
                    checkAndRequestPermissions(activity);
                } else {
                    Intent intent = new Intent(Settings.ACTION_APPLICATION_DETAILS_SETTINGS,
                            Uri.fromParts("package", activity.getPackageName(), null));
                    intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                    activity.startActivity(intent);
                }
            }
        });
        builder.setCancelable(false);
        builder.show();
    }

    //1001 == tag Data
    //1002 == clear tag
    //1003 == connected
    //1004 == disconnected


    @Override
    public void checkConnected(boolean pressed, String details) {
        if (pressed) {
            sendBroadCastDetails(1003, details, 0);
        } else {
            sendBroadCastDetails(1004, details, 0);
        }
    }

    @Override
    public void handleTagdata(TagData[] tagData) {
        final StringBuilder sb = new StringBuilder();
        for (int index = 0; index < tagData.length; index++) {
            sb.append(tagData[index].getTagID() + "\n");
        }


        sendBroadCastDetails(1001, sb.toString(), 0);

        /*runOnUiThread(new Runnable() {
            @Override
            public void run() {
                textrfid.append(sb.toString());
                Toast.makeText(MainActivity.this, "reading TAG:", Toast.LENGTH_LONG).show();
                //textrfid.append("E20000192912005607801990");
                *//*try {
                    //3000e200001929120056078019900000
                    //String iidd = textrfid.getText().toString().trim();
                    //if (!iidd.equalsIgnoreCase("")) {
                    //Toast.makeText(MainActivity.this, "iidd:" + iidd, Toast.LENGTH_LONG).show();
                    //RFIDHandler.reader.Actions.Inventory.stop();
                    RFIDHandler.reader.Actions.TagLocationing.Perform("E20000192912005607801990", null, null);
                    RFIDHandler.reader.Events.addEventsListener(MainActivity.this);
                    try {
                        Thread.sleep(5000);
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                    *//**//*} else {
                        Toast.makeText(MainActivity.this, "BLANCK" + iidd, Toast.LENGTH_LONG).show();
                    }*//**//*
                } catch (OperationFailureException e) {
                    e.printStackTrace();
                    Toast.makeText(MainActivity.this, "1:" + e.getVendorMessage(), Toast.LENGTH_LONG).show();
                    Toast.makeText(MainActivity.this, "2:" + e.getMessage(), Toast.LENGTH_LONG).show();
                } catch (InvalidUsageException e) {
                    e.printStackTrace();
                    Toast.makeText(MainActivity.this, "11:" + e.getVendorMessage(), Toast.LENGTH_LONG).show();
                    Toast.makeText(MainActivity.this, "12:" + e.getMessage(), Toast.LENGTH_LONG).show();
                }*//*

            }
        });*/
    }


    @Override
    public void handleTriggerPress(boolean pressed) {
        if (pressed) {
            /*runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    textrfid.setText("");
                    Toast.makeText(MainActivity.this, "clear TAG:", Toast.LENGTH_LONG).show();
                }
            });*/

            sendBroadCastDetails(1002, "", 0);

            rfidHandler.performInventory();
        } else
            rfidHandler.stopInventory();
    }


    /*public void eventReadNotify1(RfidReadEvents rfidReadEvents) {
        //Toast.makeText(MainActivity.this, "eventReadNotify", Toast.LENGTH_LONG).show();
        Log.e("Tags Not Found","eventReadNotify1");
        final TagData[] myTags = RFIDHandler.reader.Actions.getReadTags(100);
        if (myTags != null) {
            for (int index = 0; index < myTags.length; index++) {
                System.out.println("Tag ID " + myTags[index].getTagID());
                if (myTags[index].isContainsLocationInfo()) {
                    final int tag = index;
                    System.out.println("Tag locationing distance " +
                            myTags[tag].LocationInfo.getRelativeDistance());

                    Log.e("Tags :","Tag locationing distance " +
                            myTags[tag].LocationInfo.getRelativeDistance());
                    runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            tvPercent.setText(""+myTags[tag].LocationInfo.getRelativeDistance());
                        }
                    });

                   *//* Toast.makeText(MainActivity.this, "Tag locationing distance " +
                            myTags[tag].LocationInfo.getRelativeDistance(), Toast.LENGTH_LONG).show();*//*
                }
            }
        } else {
            //Toast.makeText(MainActivity.this, "Tags Not Found", Toast.LENGTH_LONG).show();
            Log.e("Tags Not Found","Tags Not Found");
        }
    }


    public void eventStatusNotify1(RfidStatusEvents rfidStatusEvents) {
        //Toast.makeText(MainActivity.this, "eventStatusNotify", Toast.LENGTH_LONG).show();

        Log.e("Tags Not Found","eventStatusNotify1");
        String a = "RFIDDEMO";
        StringBuilder sb = new StringBuilder();
        sb.append("Status Notification: ");
        sb.append(rfidStatusEvents.StatusEventData.getStatusEventType());
        Log.e(a, sb.toString());
        m5320a(rfidStatusEvents);

        //Toast.makeText(MainActivity.this,rfidStatusEvents.StatusEventData,Toast.LENGTH_LONG).show();
    }

    public void m5320a(RfidStatusEvents rfidStatusEvents) {
        //Runnable runnable = null;
        //final Fragment findFragmentByTag = getSupportFragmentManager().findFragmentByTag(TAG_CONTENT_FRAGMENT);
        if (rfidStatusEvents.StatusEventData.getStatusEventType() == STATUS_EVENT_TYPE.DISCONNECTION_EVENT) {
            *//*if (Application.mConnectedReader != null) {
                this.f6912C = new UpdateDisconnectedStatusTask(Application.mConnectedReader.getHostName()).execute(new Void[0]);
            }*//*

            //Toast.makeText(MainActivity.this, "DISCONNECTION_EVENT", Toast.LENGTH_LONG).show();
        } else if (rfidStatusEvents.StatusEventData.getStatusEventType() == STATUS_EVENT_TYPE.INVENTORY_START_EVENT) {
            *//*if (!Application.isAccessCriteriaRead && !Application.isLocatingTag) {
                Application.mIsInventoryRunning = true;
                Inventorytimer.getInstance().startTimer();
            }*//*

            //Toast.makeText(MainActivity.this, "INVENTORY_START_EVENT", Toast.LENGTH_LONG).show();
        } else if (rfidStatusEvents.StatusEventData.getStatusEventType() == STATUS_EVENT_TYPE.INVENTORY_STOP_EVENT) {

            //Toast.makeText(MainActivity.this, "INVENTORY_STOP_EVENT", Toast.LENGTH_LONG).show();

            *//*if (this.progressDialog != null && this.progressDialog.isShowing()) {
                this.progressDialog.dismiss();
            }
            Application.tagListMatchNotice = false;
            if (Application.mIsInventoryRunning) {
                Inventorytimer.getInstance().stopTimer();
            } else if (Application.isGettingTags) {
                Application.isGettingTags = false;
                Application.mConnectedReader.Actions.purgeTags();
                if (Application.EXPORT_DATA) {
                    if (Application.TAG_LIST_MATCH_MODE && Application.tagListFileExist) {
                        if (Application.tagsReadInventory != null && !Application.tagsReadInventory.isEmpty() && (findFragmentByTag instanceof InventoryFragment)) {
                            runnable = new Runnable() {
                                public void run() {
                                    DataExportTask dataExportTask = new DataExportTask(MainActivity.this.getApplicationContext(), ((InventoryFragment) findFragmentByTag).getAdapter().searchItemsList, Application.mConnectedDevice.getName(), Application.TOTAL_TAGS, Application.UNIQUE_TAGS, Application.mRRStartedTime);
                                    dataExportTask.execute(new Void[0]);
                                }
                            };
                        } else if (Application.tagsReadInventory != null && !Application.tagsReadInventory.isEmpty() && (findFragmentByTag instanceof RapidReadFragment) && Application.UNIQUE_TAGS != 0) {
                            Application.currentFragment = "RapidReadFragment";
                            runnable = new Runnable() {
                                public void run() {
                                    DataExportTask dataExportTask = new DataExportTask(MainActivity.this.getApplicationContext(), Application.tagsReadInventory, Application.mConnectedDevice.getName(), Application.TOTAL_TAGS, Application.UNIQUE_TAGS, Application.mRRStartedTime);
                                    dataExportTask.execute(new Void[0]);
                                }
                            };
                        }
                    } else if (Application.tagsReadInventory != null && !Application.tagsReadInventory.isEmpty()) {
                        runnable = new Runnable() {
                            public void run() {
                                DataExportTask dataExportTask = new DataExportTask(MainActivity.this.getApplicationContext(), Application.tagsReadInventory, Application.mConnectedDevice.getName(), Application.TOTAL_TAGS, Application.UNIQUE_TAGS, Application.mRRStartedTime);
                                dataExportTask.execute(new Void[0]);
                            }
                        };
                    }
                    runOnUiThread(runnable);
                }
                runOnUiThread(new Runnable() {
                    public void run() {
                        if ((findFragmentByTag instanceof ReadersListFragment) && Application.mConnectedReader != null && Application.mConnectedReader.ReaderCapabilities.getModelName() != null) {
                            ((ReadersListFragment) findFragmentByTag).capabilitiesRecievedforDevice();
                        }
                    }
                });
            }
            if (!m5345n()) {
                if (Application.mIsInventoryRunning) {
                    this.isInventoryAborted = true;
                } else if (Application.isLocatingTag) {
                    this.isLocationingAborted = true;
                }
                m5344m();
            }*//*
        } else if (rfidStatusEvents.StatusEventData.getStatusEventType() == STATUS_EVENT_TYPE.OPERATION_END_SUMMARY_EVENT) {

            //Toast.makeText(MainActivity.this, "OPERATION_END_SUMMARY_EVENT", Toast.LENGTH_LONG).show();

            *//*if (findFragmentByTag instanceof RapidReadFragment) {
                runOnUiThread(new Runnable() {
                    public void run() {
                        ((RapidReadFragment) findFragmentByTag).updateInventoryDetails();
                    }
                });
            }*//*
            //} else if (rfidStatusEvents.StatusEventData.getStatusEventType() == STATUS_EVENT_TYPE.HANDHELD_TRIGGER_EVENT && Application.isActivityVisible()) {
        } else if (rfidStatusEvents.StatusEventData.getStatusEventType() == STATUS_EVENT_TYPE.HANDHELD_TRIGGER_EVENT) {

            //Toast.makeText(MainActivity.this, "HANDHELD_TRIGGER_EVENT", Toast.LENGTH_LONG).show();

            *//*Boolean valueOf = Boolean.valueOf(false);
            if (rfidStatusEvents.StatusEventData.HandheldTriggerEventData.getHandheldEvent() == HANDHELD_TRIGGER_EVENT_TYPE.HANDHELD_TRIGGER_PRESSED) {
                valueOf = Boolean.valueOf(true);
            }
            String str = this.f6915F;
            StringBuilder sb = new StringBuilder();
            sb.append("notificationFromGenericReader ");
            sb.append(findFragmentByTag);
            sb.append(" screen ");
            sb.append(this.f6921L);
            Log.d(str, sb.toString());
            if (this.f6921L) {
                if (valueOf.booleanValue() && isTriggerImmediateorRepeat(valueOf).booleanValue() && (findFragmentByTag instanceof TriggerEventHandler)) {
                    ((TriggerEventHandler) findFragmentByTag).triggerPressEventRecieved();
                } else if (!valueOf.booleanValue() && isTriggerImmediateorRepeat(valueOf).booleanValue() && (findFragmentByTag instanceof TriggerEventHandler)) {
                    ((TriggerEventHandler) findFragmentByTag).triggerReleaseEventRecieved();
                    Application.tagListMatchNotice = false;
                }
            }*//*
        } else if (rfidStatusEvents.StatusEventData.getStatusEventType() == STATUS_EVENT_TYPE.BATTERY_EVENT) {

            //Toast.makeText(MainActivity.this, "BATTERY_EVENT", Toast.LENGTH_LONG).show();

            *//*final Events.BatteryData batteryData = rfidStatusEvents.StatusEventData.BatteryData;
            Application.BatteryData = batteryData;
            setActionBarBatteryStatus(batteryData.getLevel());
            if (f6906o != null && f6906o.size() > 0) {
                Iterator it = f6906o.iterator();
                while (it.hasNext()) {
                    ((BatteryNotificationHandler) it.next()).deviceStatusReceived(batteryData.getLevel(), batteryData.getCharging(), batteryData.getCause());
                }
            }
            if (Application.NOTIFY_BATTERY_STATUS && batteryData.getCause() != null) {
                runOnUiThread(new Runnable() {
                    public void run() {
                        MainActivity mainActivity;
                        String str;
                        MainActivity mainActivity2;
                        int i;
                        if (batteryData.getCause().trim().equalsIgnoreCase(Constants.MESSAGE_BATTERY_CRITICAL)) {
                            mainActivity = MainActivity.this;
                            str = Constants.ACTION_READER_BATTERY_CRITICAL;
                            mainActivity2 = MainActivity.this;
                            i = R.string.battery_status__critical_message;
                        } else if (batteryData.getCause().trim().equalsIgnoreCase(Constants.MESSAGE_BATTERY_LOW)) {
                            mainActivity = MainActivity.this;
                            str = Constants.ACTION_READER_BATTERY_CRITICAL;
                            mainActivity2 = MainActivity.this;
                            i = R.string.battery_status_low_message;
                        } else {
                            return;
                        }
                        mainActivity.sendNotification(str, mainActivity2.getString(i));
                    }
                });
            }*//*
        } else {
            //Toast.makeText(MainActivity.this, "Errors DDD", Toast.LENGTH_LONG).show();
        }
    }*/



}